#include <windows.h>
#include <stdio.h>
#include <process.h>
#include <stdlib.h>
#include <io.h>

#define CONFFILE "launchmirc.conf"

int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    PSTR szCmdLine, int iCmdShow) {

	char path[64], cmdline[66], *windir, confpath[64], execpath[64], errmsg[255];

	FILE *conf;

	getcwd(path, 64);

	sprintf(cmdline, "-r%s", path);

	windir = getenv("windir");
	sprintf(confpath, "%s\\%s", windir, CONFFILE);

	if ((conf = fopen(confpath, "r")) == NULL) {

		windir = getenv("USERPROFILE");
		sprintf(confpath, "%s\\%s", windir, CONFFILE);

		if ((conf = fopen(confpath, "r")) == NULL) {
		
			sprintf(errmsg, "Cannot open the %s file: %s", CONFFILE, strerror(errno));
			MessageBox (NULL, TEXT (errmsg), TEXT("Error"), 0);
			return 2;
		}
	}

	fgets(execpath, 64, conf);
	fclose(conf);

	sprintf(execpath, "%s\\mirc.exe", execpath);

	execl(execpath, "mirc", cmdline, (char *) 0);

	/* If we can read this, we're still here! */

	sprintf(errmsg, "Cannot execute application: %s", strerror(errno));
	MessageBox (NULL, TEXT (errmsg), TEXT("Error"), 0);

	return 1;
}

